--[[
@ by Ziuta
@ 03.09.2017
@ v1.0.0.0

https://www.facebook.com/ZTBModding/

You can use and edit but keep the original author ;)
]]

LockTip = {}

function LockTip.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations) and SpecializationUtil.hasSpecialization(Overloading, specializations) and SpecializationUtil.hasSpecialization(Pipe, specializations)
end

function LockTip:load(savegame)
	self.getCanTip = LockTip.getCanTip
	self.drawFix = SpecializationUtil.callSpecializationsFunction("drawFix");
	Pipe.draw = Utils.overwrittenFunction(Pipe.draw, LockTip.drawFix)
end

function LockTip:delete()
end

function LockTip:mouseEvent(posX, posY, isDown, isUp, button)
end

function LockTip:keyEvent(unicode, sym, modifier, isDown)
end

function LockTip:update(dt)
	if self.isClient then
		local animation = self.tipAnimations[self.preferedTipReferencePointIndex]		
		if self.overloading ~= nil then
			if self.pipeStateIsUnloading[self.pipeCurrentState] then
				self.getCanTip = LockTip.getCanTip
				self.getCanTipToGround = Pipe.getCanTipToGround
				self.numTipReferencePoints = 0
			else
				if self.tipReferencePoints ~= nil then
					self.numTipReferencePoints = #self.tipReferencePoints
				end
				self.getCanTip = Trailer.getCanTip
				self.getCanTipToGround = Trailer.getCanTipToGround
				if animation.name == g_i18n:getText("info_tipSideBack") or animation.name == g_i18n:getText("info_tipSideBackGrainDoor") then
					local index = self.preferedTipReferencePointIndex + 1
					if index > #self.tipReferencePoints then
						index = 1
					end
					self:togglePreferedTipReferencePointIndex(index)
				end				
			end
		end
	end
end

function LockTip:updateTick(dt)
end

function LockTip:draw(dt)
end

function LockTip:drawFix()
	if self.isClient and self:getIsActiveForInput(true) and not self:hasInputConflictWithSelection() then
		if self.hasPipe then
			if self.pipeNumStates == 2 then
				if self.pipeTargetState == 2 then
					if self:getIsPipeStateChangeAllowed(1) then
						g_currentMission:addHelpButtonText(g_i18n:getText("action_pipeIn"), InputBinding.TOGGLE_PIPE, nil, GS_PRIO_HIGH);
					end
				else
					if self:getIsPipeStateChangeAllowed(2) then
						g_currentMission:addHelpButtonText(g_i18n:getText("action_pipeOut"), InputBinding.TOGGLE_PIPE, nil, GS_PRIO_HIGH);
					end
				end
			end
		end
		if self.pipeStateIsUnloading[self.pipeCurrentState] then
	        if not self.pipeFoundTrailer and self:getCanTipToGround() and self.shovelTargetFound == nil then
	            if self.dischargeToGround then
	                g_currentMission:addHelpButtonText(g_i18n:getText("action_stopTipToGround"), InputBinding.TOGGLE_TIPSTATE_GROUND, nil, GS_PRIO_HIGH);
	            elseif not self.overloading.didOverload then
	                g_currentMission:addHelpButtonText(g_i18n:getText("action_startTipToGround"), InputBinding.TOGGLE_TIPSTATE_GROUND, nil, GS_PRIO_HIGH);
	            end
	        end
	    end
	end
end

function LockTip:getCanTip()
    return false
end